/**
 *
 * @author Bernard.Carre@polytech-lille.fr
 */

public abstract class Composant implements Comparable<Composant>   {
	//...
    public String getId() {
		
	return super.toString(); // class@numero renvoye par Object
		
    }
    public abstract String description();
    public abstract boolean getEtat() throws NonConnecteException;
    
    public String traceEtat(){
        String s = this.description();
	
	try{
	    s=s+"  "+ this.getEtat();
	}catch(NonConnecteException ex){
	    s=s+" non connecte";
	}
        return s;
    }
    public  int  compareTo(Composant c) {
	return (this.getId()).compareTo(c.getId());
    } 
}
